unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ActnList, StdCtrls, ComCtrls, ExtCtrls, frViewer,
  Menus,  IdBaseComponent,
  IdComponent, IdTCPServer,   IdIOHandler;

type
  TForm1 = class(TForm)
    ActionList_: TActionList;
    actStart: TAction;
    actStop: TAction;
    actLoad: TAction;
    GroupBox1: TGroupBox;
    btnLoad: TButton;
    btnStart: TButton;
    btnStop: TButton;
    PopupMenu_: TPopupMenu;
    IdTCPServer_: TIdTCPServer;
    Exit1: TMenuItem;
    procedure actStartExecute(Sender: TObject);
    procedure actStopExecute(Sender: TObject);
    procedure actLoadExecute(Sender: TObject);
    procedure ActionList_Update(Action: TBasicAction; var Handled: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure IdTCPServer_Execute(AThread: TIdPeerThread);

  private

  public

  end;

var
  Form1: TForm1;

implementation

uses
  VncServerAsDll;

{$R *.dfm}

procedure TForm1.ActionList_Update(Action: TBasicAction; var Handled: Boolean);
begin
  if server_instance = nil then
     server_instance := TVncServerAsDll.Create;
       
  actLoad.Enabled  := not server_instance.IsLoaded;
  actStart.Enabled := server_instance.IsLoaded and
                      not server_instance.Started;
  actStop.Enabled  := server_instance.IsLoaded and
                      server_instance.Started;

end;

procedure TForm1.actLoadExecute(Sender: TObject);
begin
//  if server_instance = nil then
//     server_instance := TVncServerAsDll.Create;

  server_instance.Load;
  server_instance.WinVNCDll_Init( HInstance );

end;





procedure TForm1.actStartExecute(Sender: TObject);
var
  props: TvncPropertiesStruct;
begin
   //create
   server_instance.WinVNCDll_CreateServer;

   //setup
   FillChar(props, SizeOf(props), 0);
   server_instance.WinVNCDll_GetProperties(@props);
   //note: properties are default or loaded from "ultravnc.ini"
   //we set some minimal values to allow local testing (in case of default values)
   props.AllowLoopback := 1;
   props.PortNumber    := 5900;
   props.password      := 'test';
   props.password_view := 'guest';
   server_instance.WinVNCDll_SetProperties(@props);

   //run!
   server_instance.WinVNCDll_RunServer;
end;

procedure TForm1.actStopExecute(Sender: TObject);
begin
   server_instance.WinVNCDll_DestroyServer;
end;


procedure TForm1.Exit1Click(Sender: TObject);
begin

   if( actStop.Enabled = false ) then
   begin
      actStopExecute( Self );
   end;

   Close;

end;

procedure TForm1.FormCreate(Sender: TObject);
begin

    //ShowMessage( IntToStr( SizeOf( TvncPropertiesStruct ) ) );

   server_instance := TVncServerAsDll.Create;
   IdTCPServer_.Active := true;

end;

procedure TForm1.IdTCPServer_Execute(AThread: TIdPeerThread);
var
    data: String; //holds string from client
begin


   data := AThread.Connection.ReadLn(); //read string from client

   if data <> '' then
   begin

      if( data = 'USVNC_START' ) then
      begin

         if( actLoad.Enabled ) then
         begin
            actLoadExecute( Self );
            actStartExecute( Self );
         end
         else
         begin
            if( actStart.Enabled ) then
            begin
               actStartExecute( Self );
            end
            else
            begin

               // it is already started ... maybe some postback shall occure :E
            end;

         end;

      end
      else
      begin

         if( data = 'USVNC_STOP' ) then
         begin
            if( actStop.Enabled ) then
            begin
               actStopExecute( Self );
            end
            else
            begin
               // it is already stoped ... maybe some postback shall occure :E
            end;

         end
         else
         begin
            // Some fuckster trying to have fun !!!
            // Kill Him with fire !!! :D
         end;

      end;


   end;

end;

end.
